// SString.h: Schnittstelle fr die Klasse SString.
//
// Copyright by Andr Stein
// E-Mail: andre_stein@gmx.de, andre_stein@web.de
// http://www.steinsoft.net
//////////////////////////////////////////////////////////////////////

#ifndef S_STRING_H
#define S_STRING_H

#include <iostream.h>

//Unicode string
typedef unsigned short wchar_t;

class SString  
{
public:
	//////////////////////
	//Konstruktoren/Destruktoren
	//////////////////////
	SString(SString& aString);
	SString(const wchar_t aChar);
	SString(const char aChar);
	SString(const double number);
	SString(const int number);
	SString(char* buffer);
	SString(wchar_t* buffer);
	SString();

	virtual ~SString();
	
	///////////////////////
	// Funktionen
	///////////////////////
	
	SString subString(int start, int end = -1);
	
	bool isEmpty();
	
	int getLength();
	int toInteger();

	const char* getCharString();

	double toDouble();
	
	void deleteAt(int index);
	void remove(SString aString, int beginAt = 0);
	void insertAt(int index, SString aString);
	void empty();
	void replace(SString what, SString result);	
	void toLowerCase();
	void toUpperCase();
	void reverse();
	void trimRight();
	void trimLeft();
	void trim();
	void printOn(ostream& output);

	///////////////////////
	// Operatoren
	///////////////////////

	SString& operator = (SString aString);
	SString  operator +(SString aString);
	void     operator +=(SString aString);
	bool     operator == (SString aString);
	bool	 operator != (SString aString);
	bool	 operator <  (SString aString);
	bool	 operator >  (SString aString);
	bool	 operator <= (SString aString);
	bool	 operator >= (SString aString);
	wchar_t& operator [] (int index);
protected:
	char* buffer;
	wchar_t* string;
	
	int size;
	int length;

};

ostream& operator << (ostream& io,SString aString);
istream& operator >> (istream& io,SString& aString);

#endif 